This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 911673 - Review Request: swell-foop - GNOME colored tiles puzzle game
Review Request: swell-foop - GNOME colored tiles puzzle game
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Kalev Lember
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-15 10:43 EST by Yanko Kaneti
Modified: 2013-03-25 16:53 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-03-25 08:06:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
yaneti: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Yanko Kaneti 2013-02-15 10:43:18 EST
Spec URL: http://declera.com/~yaneti/swell-foop/swell-foop.spec
SRPM URL: http://declera.com/~yaneti/swell-foop/swell-foop-3.7.4-1.fc19.src.rpm
Description: GNOME colored tiles puzzle game
Fedora Account System Username: yaneti

This is the upstream separation of the swell-foop from gnome-games

#rpmlint 
swell-foop.x86_64: E: incorrect-fsf-address /usr/share/doc/swell-foop-3.7.4/COPYING
swell-foop.x86_64: W: no-manual-page-for-binary swell-foop

https://bugzilla.gnome.org/show_bug.cgi?id=693893
Comment 1 Yanko Kaneti 2013-02-19 08:41:46 EST
Spec URL: http://declera.com/~yaneti/swell-foop/swell-foop.spec
SRPM URL: http://declera.com/~yaneti/swell-foop/swell-foop-3.7.90-1.fc19.src.rpm

3.7.90-1
- New upstream release 3.7.90
- Fix desktop file
Comment 2 Jeremy White 2013-02-27 10:56:47 EST
New potential packager, doing informal reviews as requested in 'How to get sponsored'.

Full review included below; the only major point I noticed was a lack of Requires for any of the gtk/glib libraries.

A minor nit - the guidelines say 'MUST' run desktop-file-install; this .spec only does a desktop-file-validate.  Not sure if this spec or the guidelines should change...

Cheers,

Jeremy


Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated

[x] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[x] MUST: The package must be named according to the Package Naming Guidelines .
[x] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 
[ ] MUST: The package must meet the Packaging Guidelines .
[x] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[x] MUST: The License field in the package spec file must match the actual license. 
[x] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[x] MUST: The spec file must be written in American English. 
[x] MUST: The spec file for the package MUST be legible. 
[x] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
[x] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. 
[?] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. 
[x] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[x] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[-] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[x] MUST: Packages must NOT bundle copies of system libraries.
[-] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. 
[!] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. 
%{_datadir}/glib-2.0/schemas/org.gnome.swell-foop.gschema.xml
[x] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[x] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. 
[x] MUST: Each package must consistently use macros. 
[x] MUST: The package must contain code, or permissable content. 
[x] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). 
[x] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. 
[-] MUST: Static libraries must be in a -static package. 
[-] MUST: Development files must be in a -devel package. 
[-] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} 
[x] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[!] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
        The package uses desktop-file-validate, not desktop-file-install, although
        it does appears to install and function properly.
[x] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[x] MUST: All filenames in rpm packages must be valid UTF-8. 

[-] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. 
[-] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. 
[x] SHOULD: The reviewer should test that the package builds in mock. 
[?] SHOULD: The package should compile and build into binary rpms on all supported architectures. 
[x] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[-] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. 
[-] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. 
[-] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. 
[-] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. 
[?] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


Rpmlint output
--------------
rpmlint swell-foop-3.7.90-1.fc18.x86_64.rpm
swell-foop.x86_64: E: incorrect-fsf-address /usr/share/doc/swell-foop-3.7.90/COPYING
swell-foop.x86_64: W: no-manual-page-for-binary swell-foop
1 packages and 0 specfiles checked; 1 errors, 1 warnings.
rpmlint swell-foop.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
Comment 3 Yanko Kaneti 2013-02-27 12:22:45 EST
Thanks for the review.

(In reply to comment #2)
> the only major point I noticed was a lack of Requires for any of the gtk/glib libraries.

The whole glib/gtk stack is standard shared libraries. RPM does auto-generate Requires on shared libraries on build time and they must not be listed explicitly.
Comment 4 Yanko Kaneti 2013-03-19 18:34:31 EDT
3.7.92-1
- Update to 3.7.92

Spec URL: http://declera.com/~yaneti/swell-foop/swell-foop.spec
SRPM URL: http://declera.com/~yaneti/swell-foop/swell-foop-3.7.92-1.fc20.src.rpm
Comment 5 Kalev Lember 2013-03-23 08:01:47 EDT
(In reply to comment #2)
> New potential packager, doing informal reviews as requested in 'How to get
> sponsored'.

Good work Jeremy!


> Full review included below; the only major point I noticed was a lack of
> Requires for any of the gtk/glib libraries.

Like Yanko said above, rpm autogenerates Requires for dynamically linked libraries, no need to list them again manually. Note the "libgtk-3.so.0()(64bit)" and others down below, this is how an autogenerated dep on the gtk library looks like.

$ rpm -qp --requires swell-foop-3.7.92-1.fc19.x86_64.rpm
/bin/sh
/bin/sh
/bin/sh
libX11.so.6()(64bit)
libXcomposite.so.1()(64bit)
libXdamage.so.1()(64bit)
libXext.so.6()(64bit)
libXfixes.so.3()(64bit)
libXi.so.6()(64bit)
libXrandr.so.2()(64bit)
libatk-1.0.so.0()(64bit)
libc.so.6()(64bit)
libc.so.6(GLIBC_2.2.5)(64bit)
libc.so.6(GLIBC_2.3.4)(64bit)
libcairo-gobject.so.2()(64bit)
libcairo.so.2()(64bit)
libclutter-1.0.so.0()(64bit)
libclutter-gtk-1.0.so.0()(64bit)
libcogl-pango.so.12()(64bit)
libcogl.so.12()(64bit)
libgdk-3.so.0()(64bit)
libgdk_pixbuf-2.0.so.0()(64bit)
libgio-2.0.so.0()(64bit)
libglib-2.0.so.0()(64bit)
libgmodule-2.0.so.0()(64bit)
libgobject-2.0.so.0()(64bit)
libgtk-3.so.0()(64bit)
libjson-glib-1.0.so.0()(64bit)
libm.so.6()(64bit)
libm.so.6(GLIBC_2.2.5)(64bit)
libpango-1.0.so.0()(64bit)
libpangocairo-1.0.so.0()(64bit)
libpthread.so.0()(64bit)
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rtld(GNU_HASH)
rpmlib(PayloadIsXz) <= 5.2-1


> A minor nit - the guidelines say 'MUST' run desktop-file-install; this .spec
> only does a desktop-file-validate.  Not sure if this spec or the guidelines
> should change...

Yeah, the wording in the guidelines is unclear. There's two distinct cases:

 1) The package doesn't include the desktop file and we instead ship one in the rpm package as a downstream change. In this case, like the guidelines say, we MUST use the 'desktop-file-install' as opposed to just copying the file to the final location.

 2) The package includes a desktop file and installs it to the final location itself. In that case, it doesn't make much sense to install it again with 'desktop-file-install'; this is where 'desktop-file-validate' is appropriate.

Also, the guidelines say that it's either one or the other. Quoting:
"one MUST run desktop-file-install (in %install) OR desktop-file-validate (in %check or %install)"
Comment 6 Kalev Lember 2013-03-23 08:16:07 EDT
I'm approving this based on Jeremy's review (thanks Jeremy!). I've done some additional checks to make sure it builds in koji and that the upgrade path looks sane, and it all looks good.

I've got two really minor nitpicks:
 a) might be nice to sort the BRs and the %files list, and
 b) the --all-name option to the %find_lang macro is unnecessary here; all the docs / translations are installed under the 'swell-food' name.

Feel free to change these before importing, if you think it makes sense.

Looks good. APPROVED
Comment 7 Yanko Kaneti 2013-03-23 08:26:09 EDT
Thanks

New Package SCM Request
=======================
Package Name: swell-foop
Short Description: GNOME colored tiles puzzle game
Owners: yaneti
Branches: f19
InitialCC:
Comment 8 Yanko Kaneti 2013-03-23 08:27:14 EDT
Messsed up the flags, sorry.
Comment 9 Jon Ciesla 2013-03-23 09:29:06 EDT
Git done (by process-git-requests).
Comment 10 Yanko Kaneti 2013-03-25 08:06:41 EDT
Built in f19 and rawhide
Comment 11 Jeremy White 2013-03-25 16:53:21 EDT
> > A minor nit - the guidelines say 'MUST' run desktop-file-install; this .spec
> > only does a desktop-file-validate.  Not sure if this spec or the guidelines
> > should change...
> 
> Yeah, the wording in the guidelines is unclear. There's two distinct cases:
> 
>  1) The package doesn't include the desktop file and we instead ship one in
> the rpm package as a downstream change. In this case, like the guidelines
> say, we MUST use the 'desktop-file-install' as opposed to just copying the
> file to the final location.
> 
>  2) The package includes a desktop file and installs it to the final
> location itself. In that case, it doesn't make much sense to install it
> again with 'desktop-file-install'; this is where 'desktop-file-validate' is
> appropriate.
> 
> Also, the guidelines say that it's either one or the other. Quoting:
> "one MUST run desktop-file-install (in %install) OR desktop-file-validate
> (in %check or %install)"

To be complete:  the detailed instructions:
  https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#desktop
are correct, but the summary page:
  https://fedoraproject.org/wiki/Packaging:ReviewGuidelines

is incomplete.  But it is such a minor nit, and rather obvious, that I don't think any change is appropriate.

Cheers,

Jeremy

Note You need to log in before you can comment on or make changes to this bug.